import java.io.*;
import java.nio.ByteBuffer;
import java.nio.ByteOrder;

/**
 * Created by IntelliJ IDEA.
 * User: bennett
 * Date: Oct 19, 2006
 * Time: 2:40:14 PM
 * To change this template use File | Settings | File Templates.
 */
public class completeImageContrasts {

    static private float readFloat(DataInputStream in) throws IOException {

        ByteBuffer bb = ByteBuffer.allocate(4).order(ByteOrder.LITTLE_ENDIAN);
        bb.put(0,in.readByte());
        bb.put(1,in.readByte());
        bb.put(2,in.readByte());
        bb.put(3,in.readByte());
        return bb.getFloat();
    }

    static private void writeFloat(DataOutputStream out,float f) throws IOException{

        ByteBuffer bb = ByteBuffer.allocate(4).order(ByteOrder.LITTLE_ENDIAN);
        bb.putFloat(0,f);
        out.writeByte(bb.get(0));
        out.writeByte(bb.get(1));
        out.writeByte(bb.get(2));
        out.writeByte(bb.get(3));
    }

    static public void main(String[] args) {


        System.out.println("Usage: completeImageContrasts doMnB0 doMnDW Nx Ny Nz (<rec> <grad> pairs)...");
        

        try {
            DataInputStream dxx,dxy,dxz,dyy,dyz,dzz;


            dxx = new DataInputStream(new BufferedInputStream(new FileInputStream(args[0]+".dxx")));
            dxy = new DataInputStream(new BufferedInputStream(new FileInputStream(args[0]+".dxy")));
            dxz = new DataInputStream(new BufferedInputStream(new FileInputStream(args[0]+".dxz")));
            dyy = new DataInputStream(new BufferedInputStream(new FileInputStream(args[0]+".dyy")));
            dyz = new DataInputStream(new BufferedInputStream(new FileInputStream(args[0]+".dyz")));
            dzz = new DataInputStream(new BufferedInputStream(new FileInputStream(args[0]+".dzz")));

            DataOutputStream out[] = new DataOutputStream[args.length-1];
            for(int j=0;j<args.length-1;j++) {
                out[j] = new DataOutputStream(new BufferedOutputStream(new FileOutputStream(args[0]+"."+args[j+1])));
            }

            DTITensor t = new DTITensor();
            int count = 0;
            try {
                while(true) {
                    count++;
                    if(count%1e3==0) {
                        System.out.print(".");
                    }
                    if(count%1e5==0) {
                        System.out.print("+\n");
                    }
                    t.setTensor(readFloat(dxx),
                            readFloat(dxy),
                            readFloat(dxz),
                            readFloat(dyy),
                            readFloat(dyz),
                            readFloat(dzz));
                    for(int j=0;j<args.length-1;j++) {
                        if(args[j+1].compareToIgnoreCase("fa")==0) {
                            writeFloat(out[j],(float)t.getFA());
                        }else if(args[j+1].compareToIgnoreCase("ra")==0) {
                            writeFloat(out[j],(float)t.getRA());
                        }else if(args[j+1].compareToIgnoreCase("sra")==0) {
                            writeFloat(out[j],(float)t.getsRA());
                        }else if(args[j+1].compareToIgnoreCase("vr")==0) {
                            writeFloat(out[j],(float)t.getVR());
                        }else if(args[j+1].compareToIgnoreCase("invvr")==0) {
                            writeFloat(out[j],(float)t.getinvVR());
                        }else if(args[j+1].compareToIgnoreCase("adc")==0) {
                            writeFloat(out[j],(float)t.getADC());
                        }else if(args[j+1].compareToIgnoreCase("vec")==0) {
                            double vec[] = t.getVec();
                            writeFloat(out[j],(float)vec[0]);
                            writeFloat(out[j],(float)vec[1]);
                            writeFloat(out[j],(float)vec[2]);
                        }else if(args[j+1].compareToIgnoreCase("cmap")==0) {
                            byte cmap[] = t.getCMAP();
                            out[j].writeByte(cmap[0]);
                            out[j].writeByte(cmap[1]);
                            out[j].writeByte(cmap[2]);
                        }else if(args[j+1].compareToIgnoreCase("eval1")==0) {
                            writeFloat(out[j],(float)t.getEval1());
                        }else if(args[j+1].compareToIgnoreCase("eval2")==0) {
                            writeFloat(out[j],(float)t.getEval2());
                        }else if(args[j+1].compareToIgnoreCase("eval3")==0) {
                            writeFloat(out[j],(float)t.getEval3());
                        } else {
                            System.out.println("Huh? "+args[j]);
                        }
                    }

                }


            } catch (EOFException eof) {

            }

            for(int j=0;j<args.length-1;j++) {
                out[j].close();
            }
            dxx.close();
            dxy.close();
            dxz.close();
            dyy.close();
            dyz.close();
            dzz.close();
            System.out.println("Done.");

            //open dxx,...
            //for each voxel, create a DTITensor
            //write out contrasts
        } catch (Exception e) {
            System.out.println(e.toString());
        }
    }
}
