function [data] = readbff(filename, type)

if( nargin == 1 )
	type = 'uint16';
end

fp = fopen(filename, 'rb', 'l');

while( 1 )

	line = fgetl(fp);

	if( length(line) >= 1 & line(1) == 12 )
		break;
	end

	if( length(line) > 6 & strcmp(line(1:6), 'nrows:') == 1 )
		nrows = str2num(line(7:end));
	end
	
	if( length(line) > 6 & strcmp(line(1:6), 'ncols:') == 1 )
		ncols = str2num(line(7:end));
	end
	
	if( length(line) > 6 & strcmp(line(1:8), 'nslices:') == 1 )
		nslices = str2num(line(9:end));
	end
	
	if( length(line) > 6 & strcmp(line(1:8), 'nechoes:') == 1 )
		nechoes = str2num(line(9:end));
	end
	
end

data = fread(fp, nrows*ncols*nslices*nechoes, type);
fclose(fp);

whos

data = squeeze(reshape( data, [nrows ncols nslices nechoes]));
