      SUBROUTINE NNLS(N, X)
C      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
C$$$$$$ CALLS H12,G1,G2 
C NON-NEGATIVE LEAST-SQUARES FITTING ROUTINE.  GIVEN BY LAWSON + HANSON 
C  IN  SOLVING LEAST SQUARES PROBLEMS ,PRENTICE-HALL 1974. 
C  GIVEN  MATRIX  A  (M BY N), AND AN M-VECTOR  B  , FINDS THE N-VECTOR 
C  X  THAT SOLVES THE PROBLEM 2-NORM(A*X - B) MINIMUM WITH X.GE.0 
C 
C  A(),MDIM,M,N  A  IS THE ARRAY, WITH MROWS,  N  COLS.  MDIM  IS THE 
C     ACTUAL DIMENSION GIVEN  A  IN THE CALLING PROGRAM (MDIM.GE.M) 
C     A  IS DESTROYED BY PROGRAM. 
C  B()  ON ENTRY MUST CONTAIN M-VECTOR  B.  DESTROYED BY PROGRAM 
C  X()  SOLUTION VECTOR  X.  NEED NOT BE INITIALIZED. 
C  RNORM  MINIMUM TWO-NORM. 
C  W()  AN ARRAY OF WORKING SPACE.  MUST BE DIMENSIONED AT LEAST N 
C  ZZ()  ANOTHER WORKING ARRAY.  MUST BE DIMENSIONED AT LEAST M. 
C  INDEX  ANOTHER WORKING ARRAY. MUST BE DIMENSIONED AT LEAST  N. 
C  MODE  A FLAG INDICATENG OUTCOME OF SUBROUTINE. 
C     MODE=1   MEANS ROUTINE WORKED PROPERLY. 
C     MODE=2   MEANS DIMENSIONS OF ARRAYS WERE BAD (M.LE0 .OR. N.LE.0) 
C     MODE=3   MEANS ITERATION COUNT EXCEEDED (MORE THAN 3*N ITERATIONS) 
C 
      DIMENSION X(N)
C 
C 
C  INITIALIZE ARRAYS INDEX  AND  X 
      DO 20 I=1,N 
 20    X(I)=ZERO 
      END                                                               NNLS 
