import java.lang.*;
import org.netlib.util.*;
import cj.*;
import apps.simple_programs.Fortran2Java.nnls.cj.Nnls;

public class NNLST2
{
    private int nrows;
    private int ncols;
    private int ndata;
    private double[] w;
    private double[] zz;
    doubleW rnorm;
    int[] index;
    double[] a;
    intW mode;
    Nnls nnls;

    public void NNLST2() {
    }

    public void create(double[] te_in, double[] t2_in) {

        nrows = te_in.length;
        ncols = t2_in.length;
        ndata = nrows;

        a = new double[nrows*ncols];
        for(int ii=0; ii<nrows*ncols; ii++) {
            a[ii] = Math.exp( - te_in[ii%nrows] / t2_in[ii/nrows] );
//			System.out.print(a[ii] + " ");

            if( ii%ncols == (ncols-1) ) {
//				System.out.println();
            }
        }

        //
        // setup internal variables.
        //
        try {
            w = new double[ncols];
            zz = new double[nrows];
            index = new int[ncols];
        }
        catch (Exception e) {
            System.err.println("Caught IOException: " + e.getMessage());
            System.exit(0);
        }

        for( int ii=0; ii<nrows; ii++) {
            zz[ii] = 0;
        }

        for( int ii=0; ii<ncols; ii++) {
            w[ii] = 0.0;
            index[ii] = 0;
        }

        nnls = new Nnls();

        mode = new intW(0);
        rnorm = new doubleW(0.0);

    }

    public void compute( double[] b, double[] x) {
        nnls.nnls(a, 0, nrows, nrows, ncols, b, 0, x, 0, rnorm,
                  w, 0, zz, 0, index, 0, mode);
        System.out.println("Rnorm is " + rnorm.val);
        System.out.println("Mode is " + mode.val);

        for(int ii=0; ii<x.length; ii++) {
            if( x[ii] > 0 ) {
                System.out.println("x " + x[ii]);
            }
        }
    }
}
