package apps.simple_programs.Fortran2Java.nnls.cj;/*
 *  Produced by f2java.  f2java is part of the Fortran-
 *  -to-Java project at the University of Tennessee Netlib
 *  numerical software repository.
 *
 *  Original authorship for the BLAS and LAPACK numerical
 *  routines may be found in the Fortran source, available at
 *  www.netlib.org.
 *
 *  Fortran input file: nnls.f
 *
 *  The f2j compiler code was written by
 *  David M. Doolin (doolin@cs.utk.edu) and
 *  Keith  Seymour (seymour@cs.utk.edu)
 */

import java.lang.*;
import org.netlib.util.*;



public class H12 {

// C      IMPLICIT DOUBLE PRECISION (A-H,O-Z) 
static double cl= 0.0;
static double sm= 0.0;
static double sm1= 0.0;
static double clinv= 0.0;
static double b= 0.0;
static int mdim= 0;
static int i1= 0;
static int i2= 0;
static int i3= 0;
static int i4= 0;
static int i= 0;
static int j= 0;
static int incr= 0;
// C$$$$$ CALLS NO OTHER ROUTINES 
// C  CONSTRUCTION AND APPLICATION OF HOUSEHOLDER TRANSFORMATION FOR
// C  MODIFIED FROM  H12  IN LAWSON+HANSEN - SOLVING LEAST SQUARES 
// C  - PRENTICE-HALL 1974 (PP308,309).  DOUBLE PRECISION THROUGHOUT 

public static void h12 (int mode,
int lpivot,
int l1,
int m,
double [] u, int _u_offset,
int iue,
doubleW up,
double [] c, int _c_offset,
int ice,
int icv,
int ncv)  {

if (0 >= lpivot || lpivot >= l1 || l1 > m)  
    Dummy.go_to("H12",999999);
cl = Math.abs(u[(1)- 1+(lpivot- 1)*iue+ _u_offset]);
if (mode == 2)  
    Dummy.go_to("H12",60);
// C  CONSTRUCT TRANSFORMATION 
{
forloop10:
for (j = l1; j <= m; j++) {
Dummy.label("H12",10);
cl = Math.max(Math.abs(u[(1)- 1+(j- 1)*iue+ _u_offset]), cl) ;
}              //  Close for() loop. 
}
if ((cl) < 0)  
      Dummy.go_to("H12",130);
else if ((cl) == 0)  
      Dummy.go_to("H12",130);
else   Dummy.go_to("H12",20);
label20:
   Dummy.label("H12",20);
clinv = 1.0/cl;
sm = Math.pow((u[(1)- 1+(lpivot- 1)*iue+ _u_offset]*clinv), 2);
{
forloop30:
for (j = l1; j <= m; j++) {
Dummy.label("H12",30);
sm = Math.pow((u[(1)- 1+(j- 1)*iue+ _u_offset]*clinv), 2)+sm;
}              //  Close for() loop. 
}
sm1 = sm;
cl = Math.sqrt(sm1)*cl;
if ((u[(1)- 1+(lpivot- 1)*iue+ _u_offset]) < 0)  
      Dummy.go_to("H12",50);
else if ((u[(1)- 1+(lpivot- 1)*iue+ _u_offset]) == 0)  
      Dummy.go_to("H12",50);
else   Dummy.go_to("H12",40);
label40:
   Dummy.label("H12",40);
cl = -cl;
label50:
   Dummy.label("H12",50);
up.val = u[(1)- 1+(lpivot- 1)*iue+ _u_offset]-cl;
u[(1)- 1+(lpivot- 1)*iue+ _u_offset] = cl;
Dummy.go_to("H12",70);
// C  APLLY TRANSFORMATION 
label60:
   Dummy.label("H12",60);
if ((cl) < 0)  
      Dummy.go_to("H12",130);
else if ((cl) == 0)  
      Dummy.go_to("H12",130);
else   Dummy.go_to("H12",70);
label70:
   Dummy.label("H12",70);
if (ncv <= 0)  
    Dummy.go_to("H12",999999);
b = up.val*u[(1)- 1+(lpivot- 1)*iue+ _u_offset];
if ((b) < 0)  
      Dummy.go_to("H12",80);
else if ((b) == 0)  
      Dummy.go_to("H12",130);
else   Dummy.go_to("H12",130);
label80:
   Dummy.label("H12",80);
b = 1.0/b;
i2 = 1-icv+ice*(lpivot-1);
incr = ice*(l1-lpivot);
{
forloop120:
for (j = 1; j <= ncv; j++) {
i2 = icv+i2;
i3 = i2+incr;
i4 = i3;
sm = c[(i2)- 1+ _c_offset]*up.val;
{
forloop90:
for (i = l1; i <= m; i++) {
sm = c[(i3)- 1+ _c_offset]*u[(1)- 1+(i- 1)*iue+ _u_offset]+sm;
Dummy.label("H12",90);
i3 = ice+i3;
}              //  Close for() loop. 
}
if ((sm) < 0)  
      Dummy.go_to("H12",100);
else if ((sm) == 0)  
      Dummy.go_to("H12",120);
else   Dummy.go_to("H12",100);
label100:
   Dummy.label("H12",100);
sm = b*sm;
c[(i2)- 1+ _c_offset] = sm*up.val+c[(i2)- 1+ _c_offset];
{
forloop110:
for (i = l1; i <= m; i++) {
c[(i4)- 1+ _c_offset] = sm*u[(1)- 1+(i- 1)*iue+ _u_offset]+c[(i4)- 1+ _c_offset];
Dummy.label("H12",110);
i4 = ice+i4;
}              //  Close for() loop. 
}
Dummy.label("H12",120);
}              //  Close for() loop. 
}
label130:
   Dummy.label("H12",130);
Dummy.go_to("H12",999999);
Dummy.label("H12",999999);
return;
   }
} // End class.
