#include <stdio.h>
#include <math.h>
#include <f2c.h>

#define NROWS 5
#define NCOLS 10

void MAIN__() {};
int nnls_(doublereal *a, integer *mdim, integer *m, integer *
	n, doublereal *b, doublereal *x, doublereal *rnorm, doublereal *w, 
	doublereal *zz, integer *index, integer *mode);

int main()
{
	int ii, row, col;

	double te[NROWS];
	double t2[NCOLS];
	double b[NROWS];
	double A[NROWS*NCOLS];
	double x[NCOLS];
	double zz[NROWS];
	double w[NCOLS];
	long index[NCOLS];
	double rnorm;
	long mode;

	long nrows = NROWS;
	long ncols = NCOLS;
	long ndata = nrows;

	for(ii=1; ii<=nrows; ii++) {
		te[ii-1] = ((double)ii)*10.0;
	}

	for(ii=1; ii<=ncols; ii++) {
		t2[ii-1] = ((double)ii)*10.0;
	}

	for(ii=0; ii<nrows; ii++) {
		b[ii] = exp( -te[ii] / 40.0 );
	}

	for(ii=0; ii<nrows*ncols; ii++) {
//		A[ii] = exp( -te[ii/ncols] / t2[ii%ncols] );
		A[ii] = exp( -te[ii%nrows] / t2[ii/nrows] );
	}

	for(row=0; row<nrows; row++) {
		for(col=0; col<ncols; col++) {
			printf("%5.4f ", A[row*ncols+col]);
		}
		printf("\n");
	}
	
	nnls_(A, &nrows, &nrows, &ncols, b, x, &rnorm, w, zz, index, &mode);

	for(ii=0; ii<ncols; ii++) {
		printf("t2=%f  x=%f\n", t2[ii], x[ii]);
	}
	printf("rnorm = %f\n", rnorm);
}
