import java.applet.*;
import java.awt.*;
import java.awt.image.*;
import java.io.*;
import javax.swing.*;

// This applet creates an image from an array of color values
// and displays it.

public class MemoryImage extends Applet
{

	public static int imageData[];
	public static short imageDatas[];
	public static JFrame appletFrame;
	public static JSlider slider;
	public JPanel pane;

   public Image smiley;
   public MemoryImageSource mi;

   public static void main(String args[])
   {
		appletFrame = new JFrame("Image");
		DataInputStream ds;
		FileInputStream fis;

		//
		JFrame dialogFrame = new JFrame("Show image");
		FileDialog fd = new FileDialog(dialogFrame, "test");
		fd.setDirectory("/home/craig/work/Data/MRI/Anne_CPMG/");
		fd.show();
		dialogFrame.dispose();

		JDialog jt = new JDialog(dialogFrame, "Loading data...");
		//
		//  File stuff.
		//
		try {
			fis = new FileInputStream(fd.getDirectory() + fd.getFile());
			ds = new DataInputStream(fis);

			ds.skip(7904);
		}
		catch( IOException e)
		{ 
			System.out.println("Could not find the file.");
			return;
		}

		//
		//  Fill up the matrix.
		//
		int i, max_i = 0;

		imageData = new int[256*256];
		for( int ii=0; ii<256; ii++) {
			for( int jj=0; jj<256; jj++) {
				try {
					i = ds.readUnsignedShort();
				} catch(IOException e) {return;};

				imageData[ii*256 + jj] = i;

				if( imageData[ii*256+jj] > max_i ) {
					max_i = imageData[ii*256+jj];
				}

			}
		}

		//
		//  Scale the image.
		//
		float f;
		for( int ii=0; ii<256; ii++) {
			for( int jj=0; jj<256; jj++) {
				f = (float)imageData[ii*256+jj];
				f = (int)((f / ((float)max_i)) * 255.0);

				if( f > 255 ) 
					f = 255;

				i = (int)f;
				i = i & 0xff;

				imageData[ii*256 + jj] = ( (255<<24) | (i<<16) | (i<<8) | i);
			}
		}


//		jt.dispose();

		// The frame needs a layout manager, use the GridLayout to maximize
		// the applet size to the frame.
		// appletFrame.getContentPane().setLayout(new GridLayout(2,1));

		// Have to give the frame a size before it is visible
		appletFrame.setSize(256+30, 256+20);
		appletFrame.setVisible(true);

		// Create an instance of the applet
		Applet myApplet = new MemoryImage();

		// Add the applet to the frame
		appletFrame.getContentPane().add(myApplet);

		// Add Button
		slider = new JSlider(JSlider.HORIZONTAL, 1, 24, 1);
		slider.setMajorTickSpacing(5);
		slider.setMinorTickSpacing(5);
		slider.setPaintTicks(true);
		slider.setPaintLabels(true);
		slider.setBorder(BorderFactory.createEmptyBorder(0,0,10,0));

		myApplet.init();


		// Initialize and start the applet
		myApplet.start();
   }
   	
   public void init()
   {
		mi = new MemoryImageSource(256, 256, imageData, 0, 256);

		smiley = createImage(mi);

		pane = new JPanel();
		pane.setSize(new Dimension(256,256));
		appletFrame.getContentPane().add(pane);
		pane.setBorder(BorderFactory.createEmptyBorder(0,0,10,0));
		appletFrame.getContentPane().add(slider);

   }

   public void paint(Graphics g)
   {
		pane.getGraphics().drawImage(smiley,0,0,256,256,this);
   }
}
