import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;


class ChartPanel extends JPanel {
	int width;
	int height;
	static int border = 40;

	Font font;

	boolean showLine_f;

	int max_x, max_y;
	int x_raw[];
	int y_raw[];
	int x[];
	int y[];

	ChartPanel() {
		width = 256;
		height = 256;

		x = null;
		y = null;

		showLine_f = true;
		font = new Font("helvetica", Font.PLAIN, 10);
	}

	public void setY( int[] y_in ) {

		x = new int[y_in.length];
		y = new int[y_in.length];
		for(int ii=0; ii<y.length; ii++) {
			x[ii] = ii+1;
			y[ii] = y_in[ii];
		}

		for(int ii=0; ii<x.length; ii++) {
			//
			//  Find maximum x value.
			//
			max_y = Math.max( y[ii], max_y );

			//
			//  Find maximum x value.
			//
			max_x = Math.max( x[ii], max_x );
		}
	}

	public void setXY( int[] x_in, int[] y_in ) {

		if( x_in.length != y_in.length ) {
			System.out.println("The vectors are not the same length.");
			System.exit(-1);
		}

		x = new int[x_in.length];
		y = new int[y_in.length];
		for(int ii=0; ii<x.length; ii++) {
			x[ii] = x_in[ii];
			y[ii] = y_in[ii];
		}

		for(int ii=0; ii<x.length; ii++) {
			//
			//  Find maximum x value.
			//
			max_y = Math.max( y[ii], max_y );

			//
			//  Find maximum x value.
			//
			max_x = Math.max( x[ii], max_x );
		}

	}

	private int scaleX(int x_in) {
		int x_out;

		x_out = (int)((float)x_in / (float)max_x * 
					 ((float)getWidth()-2*border))+border;

		return x_out;
	}

	private int scaleY(int y_in) {
		int y_out;

		y_out = getHeight()-(int)((float)y_in / (float)max_y * 
								  ((float)getHeight()-2*border)) - border; 

		return y_out;
	}

	public void showLine( boolean show ) {
		showLine_f = show;
	}

	public void paintComponent(Graphics g) {
		System.out.println("chartPanel::paintComponent " + x.length);

		g.clearRect(0, 0, getHeight(), getWidth());

		//  x-axis
		g.drawLine(border, getHeight()-border, getWidth(), getHeight()-border);

		//  y-axis
		g.drawLine(border, getHeight()-border, border, border);

		if( x.length > 0 ) {
			for(int ii=0; ii<x.length; ii++) {
				g.fillOval(scaleX(x[ii])-2, scaleY(y[ii])-2, 5, 5);

				if( showLine_f && ii > 0 ) {
					g.drawLine(scaleX(x[ii-1]), scaleY(y[ii-1]), 
							   scaleX(x[ii]), scaleY(y[ii]));
				}
			}

			g.setFont(font);
			for(int ii=0; ii<x.length; ii=ii+10) {
				g.drawLine(scaleX(x[ii]), getHeight()-border-5, 
						   scaleX(x[ii]), getHeight()-border+5);
				g.drawString(""+ii, scaleX(x[ii])-(""+ii).length(), 
							 getHeight()-15);
			}
		}
	}
}
