import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import java.lang.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.image.*;

class Volume {

	private int nx;
	private int ny;
	private int nz;
	private int[] data;

	//-----------------------------------------------------
	//
	//  Constructor
	//
	Volume(int nx_in, int ny_in, int nz_in) {
		nx = nx_in;
		ny = ny_in;
		nz = nz_in;
	}

	public void read( DataInputStream ds ) {
	
		try {

			byte[] tmpData = new byte[nx*ny*nz*2];

			ds.readFully( tmpData, 0, nx*ny*nz*2 );

			data = new int[nx*ny*nz];

			//
			// Copy over the data and swap the bytes.  Seems to be
			// correct.
			//
			int tlow;
			int thigh;
			for( int ii=0; ii<nx*ny*nz; ii++) {
				tlow = (int)(tmpData[2*ii]&0x000000FF);
				thigh = (int)(tmpData[2*ii+1]&0x000000FF);

				data[ii] = (int)( (tlow) | (thigh<<8) );
			}
		}
		catch( IOException e ) {
			System.out.println("Could not find the file.");
			System.exit(0);
		}

	}

	//-----------------------------------------------------
	//
	//  Data Returns. 
	//
    public int nX() {
		return nx;
	}

    public int nY() {
		return ny;
	}

    public int nZ() {
		return nz;
	}

	public int getMax() {
		int max=0;

		for(int ii=0; ii<nx*ny*nz; ii++ ) {
			if( data[ii] > max ) {
				max = data[ii];
			}
		}

		return max;
	}

	public int getElement( int index ) {
		return data[index];
	}

	public void show() {
		System.out.println("The volume is " + nx + "x" + ny + "x" + nz);
	}

	public int[] getSlice( int slice_num ) {
		
		//
		//  Check the number of slices.
		//
		if( slice_num > nz ) {
			System.out.println("WRong number of slices");
			System.exit(-1);
		}

		int toreturn[] = new int[nx*ny];

		for( int ii=0; ii<nx*ny; ii++ ) {
			toreturn[ii] = data[ slice_num*nx*ny + ii ];
		}

		return toreturn;
	}
}
