function [data] = readbff(filename, type)

if( nargin == 1 )
	type = 'uint16';
end

if( ~isempty(findstr(filename, 'gz') ) )
	filename_temp = tempname;
	unix(sprintf('gzcat %s > %s', filename, filename_temp));
	filename = filename_temp;
end

fp = fopen(filename, 'rb', 'l');

while( 1 )

	line = fgetl(fp)

	if( length(line) >= 1 & line(1) == 12 )
		break;
	end

	if( length(line) > 6 & strcmp(line(1:6), 'nrows:') == 1 )
		nrows = str2num(line(7:end));
	end
	
	if( length(line) > 6 & strcmp(line(1:6), 'ncols:') == 1 )
		ncols = str2num(line(7:end));
	end
	
	if( length(line) > 6 & strcmp(line(1:8), 'nslices:') == 1 )
		nslices = str2num(line(9:end));
	end
	
	if( length(line) > 6 & strcmp(line(1:8), 'nechoes:') == 1 )
		nechoes = str2num(line(9:end));
	end
	
	if( length(line) > 6 & strcmp(line(1:10), 'nchannels:') == 1 )
		nchannels = str2num(line(11:end));
	end
	
	if( length(line) > 4 & strcmp(line(1:5), 'type:') == 1 )
		type = strrep(line(6:end), ' ', '');
	end
	
	if( length(line) > 6 & strcmp(line(1:7), 'endian:') == 1 )
		endian = strrep(line(8:end), ' ', '');
	end
	
end
fclose(fp);

%%  Read in data
if( strcmp( endian, 'little' ) )
	endian = 'l';
elseif( strcmp( endian, 'big') )
	endian = 'b';
else
	endian = 'native';
end

fp = fopen(filename, 'rb', endian);
while( 1 )
	line = fgetl(fp);
	if( length(line) >= 1 & line(1) == 12 )
		break;
	end
end
data = fread(fp, nrows*ncols*nslices*nchannels, type);
fclose(fp);

data = squeeze(reshape( data, [nrows ncols nslices nchannels]));
